---
title: Debug eval sources
slug: Tools/Debugger/How_to/Debug_eval_sources
---
<div>{{ToolsSidebar}}</div>

<p>You can debug JavaScript code that is evaluated dynamically, either as a string passed to <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/eval"><code>eval()</code></a> or as a string passed to the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function"><code>Function</code></a> constructor.</p>

<p>In the video below, we load a page containing a source like this:</p>

<pre class="brush: js">var script = `function foo() {
               console.log('called foo');
             }
             //# sourceURL=my-foo.js`;

eval(script);

var button = document.getElementById("foo");
button.addEventListener("click", foo, false);
</pre>

<p>The evaluated string is given the name "my-foo.js" using the <code>//# sourceURL</code> directive. This source is then listed in the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_list_pane">source list pane</a>, and can be opened and debugged like any other source.</p>

<p>{{EmbedYouTube("AkvN40-y1NE")}}</p>

<p>The name of the source will also appear in stack traces appearing in the <a href="/en-US/docs/Tools/Web_Console#Error_messages">Web Console</a>.</p>

<p>The debugger will also stop at <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/debugger">debugger;</a></code> statements in unnamed eval sources.</p>
